///////////////////////////////////////////////////////////////////////////
// Filename	: Vision.h
// Created	: Tuesday, June 17th, 1997
// Description: A class to do all the computer vision processing
// 
// by Nuria Oliver 1997, nuria@media.mit.edu
///////////////////////////////////////////////////////////////////////////
// Vision.h : header file
//
#ifndef _TCIGRABBER_H
#define _TCIGRABBER_H

//#define _EVENTSUPPORT
#define HOST_FRAME_BUFFER	1
#define VGA_FRAME_BUFFER	0

#include "OdxIsr.h"
#include "ImgWnd.h"
#include "StaticFrame.h"
#include <afxmt.h>
#include "UErrors.h"
#include "UBitMap.h"

class VTciGrabber;

struct ThreadParams	{
	VTciGrabber *grabber;
	BOOL		display;
	CDisplay	*disp;
	CListBox	*lbMsgs;
	HWND		hParentWnd;
};

class VTciGrabber	{
	friend UINT GrabThread(LPVOID param);
public:
	ErrorNumber DirtyReduce(TBitMap &dest, int factor = 2);
	void StartGrab(HWND hWnd, CListBox *lstBox, CStaticFrame *disp, BOOL display);
	void StopGrab();
	void Snap(CImgWnd *disp);
	int Width()		{ return m_nWidth; }
	int Height()	{ return m_nHeight; }
	int PixelSize()	{ return m_nPixSize; }
	BOOL Grabbing()	{ return m_bGrabbing; }
	void Dispose();
	BOOL Init(CStringList *msgs = 0, int res_factor = 2);
	VTciGrabber();
	~VTciGrabber();


protected:
	HGLOBAL hBuf;
	ThreadParams params;
	BOOL m_bGrabbing;
	LPVOID m_lpBits;
	CEvent stopEvent;
	int m_nPixSize;
	int m_nWidth;
	int m_nHeight;
	void * ImgBuf2;
	void * ImgBuf1;
};

#endif
