/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

#if !defined(AFX_DISPLAYDIALOG_H__B07A87B9_FE23_11D0_ACB2_00A0C9064703__INCLUDED_)
#define AFX_DISPLAYDIALOG_H__B07A87B9_FE23_11D0_ACB2_00A0C9064703__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// DisplayDialog.h : header file
//

#ifndef _DISPLAYDLG_H
#define _DISPLAYDLG_H

/////////////////////////////////////////////////////////////////////////////
// CDisplayDialog dialog
#include "VDib.h"
#include "resource.h"

#define WM_DDGOODBYE WM_USER + 1200
#define WM_REFRESH WM_USER + 1201

class CDisplayDialog : public CDialog
{
	// Construction
	//private:
public:
	CDialog* m_pDlg;
public:
	CDisplayDialog(CWnd* pParent = NULL, int	id = 0 );   // standard constructor
	CDisplayDialog(CDialog* pDlg, int	id = 0 );
	
	virtual BOOL Create( int nPixSize, int Width, int Height );
	virtual BITMAPINFO_8	BmInfo() {return m_stdBmInfo;}
	
	virtual void CenterBitmap( ) = 0;
	int		  ID() { return m_nID;}
	
	void Hide() { SetWindowPos(&wndTop,0,0,0,0, SWP_HIDEWINDOW| SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER); }
	void Show()  { SetWindowPos(&wndTop,0,0,0,0, SWP_SHOWWINDOW| SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER); }
	void	Quit() { OnClose();}
	
	// Dialog Data
	//{{AFX_DATA(CDisplayDialog)
	enum { IDD = IDD_DISPLAYDIALOG };
	// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA
	
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDisplayDialog)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	int				m_nHeight;
	int				m_nWidth;
	int				m_nID;
	BITMAPINFO_8	m_stdBmInfo;
	
	// Generated message map functions
	//{{AFX_MSG(CDisplayDialog)
	afx_msg void OnClose();
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
		
private:
	void CleanUp();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.
#endif

#endif // !defined(AFX_DISPLAYDIALOG_H__B07A87B9_FE23_11D0_ACB2_00A0C9064703__INCLUDED_)

