///////////////////////////////////////////////////////////////////////////
// Filename	: ImgWndBB.h
// Created	: Tuesday, June 17th, 1997
// Description: A window class to display images.
// 
//  Vasanth Philomin 1997, vasi@cs.umd.edu
///////////////////////////////////////////////////////////////////////////
// ImgWnd.h : header file
//
#ifndef _IMGWNDBB_H
#define _IMGWNDBB_H

#include "ImgWnd.h"
#include "UPoint.h"
#include <afxtempl.h>

// Define the instantiation of CArray to array of CPoint&
typedef  CArray< TPoint, TPoint& > TPointArray;

/////////////////////////////////////////////////////////////////////////////
// CImgWndBB frame

class CImgWndBB : public CImgWnd
{

// Attributes
public:
	void SetRect(CRect &rect)	{ m_rect = rect; }
	void SetEigPoints(TPointArray &arrEigPoint)	{ m_arrEigPoint.Copy( arrEigPoint ); }
	CImgWndBB();
	BOOL Create(const char *strTitle, const CPoint &topLeftCorner, BITMAPINFO_8 &bmInfo, BOOL bMatchScreen = TRUE, BOOL bDrawBB = FALSE);
	void SetDrawBB() { m_bDrawBB = TRUE; }
	void UnsetDrawBB() { m_bDrawBB = FALSE; }

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CImgWndBB)
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CImgWndBB();

	// Generated message map functions
	//{{AFX_MSG(CImgWndBB)
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CBrush	m_brush;
	CPen	m_pen;
	CRect   m_rect;
	BOOL    m_bDrawBB;
    TPointArray m_arrEigPoint;
};

/////////////////////////////////////////////////////////////////////////////

#endif
