/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

// File       : UBitMap.h
// Creation   : 03/1994
//              Statistics and other features (Gaussian) from N. Oliver Ramirez
//              RotatedCopy based on G. Hager X-Vision lib
//              Several contribution from many peoples
//
// Goal       : declares the TBitMap class, wich stores a bitmap image and
//              provides some operators on it.
//
// Tab        : 2
//  Nuria Oliver 1997, nuria@media.mit.edu


// Main revisions :

#ifndef _BITMAP_H
#define _BITMAP_H

// Standard includes

// Project interfaces
#include "UErrors.h"
#include "VDib.h"

// TBitMapSpec            errors ranges from 1040 to 1059


class TBitMap	: public VDib	{
	
protected:
	LPBYTE m_pBuf; // Memory where to store the pixels
public:
	TBitMap() : m_pBuf(0)	{ }
	void Dispose();
	LPBYTE GetBuffer();
	int Height();
	void Init(const BITMAPINFO_8 &bmInfo);
};

inline int TBitMap::Height()
{
	return abs(m_bmHeader.bmiHeader.biHeight);
}

inline LPBYTE TBitMap::GetBuffer()
{	
	return m_pBits;
}

#endif
