// File       : ULearn.h
// Creation   : Feb 1997
// Creator    : N.OLIVER
// Goal       : declares TLearn virtual class. A class that defines the
//              method for learning new statistical models
//
// Tab        : yes

#ifndef _ULEARN_H
#define _ULEARN_H

// project includes
#include "UTypesMutex.h"
#include <afxmt.h>

class TLearn
{
  public :

  virtual ErrorNumber     Init (TMixGaussMutex* models, 
				TBitMap*        source,
				TROIMutex*      roi,
				TFlagMutex*     flag = (TFlagMutex*)NULL,
				BOOL         interior = TRUE);
  // initialise the learning class

  virtual	void			Start();
  virtual	void			Stop();
  virtual void            Dispose ();
  // release camera control ressources

  protected :
  TMixGaussMutex* m_pOutputModels;
  TBitMap*        m_pBm;
  TROIMutex*      m_pBb;
  TFlagMutex*     m_pLearnFlag;
  BOOL         m_bInterior;
  BOOL			m_bLearning;
	CEvent		stopEvent;

  // Null initialisation for virtual functions
  virtual   ErrorNumber     Learn( ) = 0;

  friend    UINT            LearnThread (LPVOID userData);
};


#endif


