/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

// File       : UPoint.h
// Creation   : 07/07/97
// Goal       : declares the TPoint class, which is an extension of the 
//				standard CPoint
//
//  Nuria Oliver 1997, nuria@media.mit.edu

#ifndef _UPOINT_H
#define _UPOINT_H

#include <afxtempl.h>

class TPoint : public CPoint
{
public:
	TPoint() : CPoint() { }
	TPoint( int x, int y ) : CPoint( x, y ) { }
	TPoint( TPoint& p ) : CPoint( p.x, p.y ) { }
	TPoint& operator=(  const TPoint& val ) { x = val.x; y = val.y; return *this; }
	
protected :
	
};

typedef  CArray< TPoint, TPoint& > TPointArray;

#endif
