/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

// File       : UTimer.h
// Creation   : 07/1996
// Goal       : declares the TTimer class, which give 1/1000 s. ticks
//
// Tab        : no

#ifndef _UTIMER_H
#define _UTIMER_H

// project includes
#include "UErrors.h"

// system includes
//#include <sys/time.h>
#include <mmsystem.h>


const UINT      kTimerNbTiksPerSecond     = 1000;

class TTimer
{
public:
	
    ErrorNumber         Init ()
	{ m_nLastTick = this->Time ();
	return kErrNoErr; }
	
    void                Dispose () {}
	
    inline UINT         Time ();
    // returns the current ticks value, 1 tick is 1/1000 second
	
    inline UINT         Gap ();
    // returns the number of ticks ellapsed since last call to "Gap"
	
	
protected :
	
    UINT                m_nLastTick;
	
};


//
//    Time
//

UINT TTimer::Time ()
{
	return timeGetTime();
}




//
//    Gap
//

UINT TTimer::Gap ()
{
	UINT  theLast = m_nLastTick;
	
	m_nLastTick = this->Time ();
	
	return m_nLastTick - theLast;
}



#endif
