//
//	     File : UTypes.h
//	     Date : 07/95
//	     Goal : Global custom type definitions
//
//    Main modifs : N.Oliver (7/96) new functionality in TRect
//


#ifndef __UTypes_H_
#define __UTypes_H_

// project includes
//#include "UArch.h"

// ANSI includes
#include <stdlib.h>    // for the definition of size_t
//#include <strstream.h> // for the implementation of the string conversion functions
//#include <string.h>

// plateform specific includes
#ifdef __IRIX__
#include <sys/types.h>
#endif




////////// Custom type definitions

#ifndef __Mac__
typedef unsigned char		UInt8;		  // 1 byte integer
typedef unsigned short		UInt16;		  // 2 bytes integer
typedef unsigned long		UInt32;		  // 4 bytes integer

typedef signed char		SInt8;		  // 1 byte signed integer
typedef signed short		SInt16;		  // 2 bytes signed integer
typedef signed long		SInt32;		  // 4 bytes signed integer

//typedef enum {false = 0, true = 1}  Boolean;
#endif

typedef float			Float32;	  // 4 bytes float

typedef size_t			BlockSize;
typedef void*			Pointer;

#ifdef __Mac__
typedef SInt32			ProcessID;
#else
//typedef pid_t			ProcessID;
typedef UINT 			ProcessID;

#endif

typedef void			CallBack (Pointer param);


#ifndef NULL
#define NULL (Pointer)0
#endif

class TRect
{
  public :

    SInt32 left;
    SInt32 top;
    SInt32 right;
    SInt32 bottom;


  TRect() {};
    // Attention to the order of the parameters!!
    TRect(SInt32 t, SInt32 b, SInt32 l, SInt32 r) :
  left(l), top(t), right(r), bottom(b) {};

    ~TRect() {};

    SInt32 width() { return right-left; }
    SInt32 height() { return bottom-top; }

    inline void set( TRect& t ) 
    { top=t.top; bottom=t.bottom; left=t.left; right=t.right;}
    inline void set( SInt32 t, SInt32 b, SInt32 l, SInt32 r  ) 
    { top=t; bottom=b; left=l; right=r;}
    inline void operator=( TRect& t ) { set( t ); }
    
    inline int operator==( TRect& t ) const;

    //inline void getStringValue(char* s);
    //inline void setStringValue( char *s );
};

int
TRect::operator==( TRect& t ) const
{
    return( (top==t.top) && (bottom==t.bottom) && (left==t.left) &&
	    (right==t.right) );
}


#if 0
void TRect::getStringValue(char* s)
{
    //returns a string with the values of the data members in the
    //following order
    //left
    //top
    //right
    //bottom

    strstream ios( s, 50, ios::out );
    ios << left << " " << top << " " << right << " " << bottom << '\0'; 
}
  
void TRect::setStringValue(char *s)
{
    //returns a string with the values of the data members in the
    //following order
    //left
    //top
    //right
    //bottom
    float aux;
    strstream ios( s, strlen(s), ios::in );
    ios >> aux; left=(SInt32)aux;
    ios.ignore(1);
    ios >> aux; top=(SInt32)aux;
    ios.ignore(1);
    ios >> aux; right=(SInt32)aux;
    ios.ignore(1);
    ios >> aux; bottom=(SInt32)aux;
}
#endif

#endif




