#ifndef _CORSTD_H_
#define _CORSTD_H_

/*************************************************************************
   This file contains Standard Definitions.

   Variable Prefixes used:
           array: a
            BOOL: b
            BYTE: by
            char: c
            WORD: w
           DWORD: dw
            UINT: u
            LONG: l
             int: i
    near pointer: np
    long pointer: lp

       bit field: f

History:

$Log: corstd.h $
Revision 1.8  1997/02/13 12:13:46  ADR
- define COR_ENABLE/DISABLE for WC
- do not define ODXPARM if _STD_H has already been defined
Revision 1.7  1997/01/17 23:22:56  ADR
COR_ENABLE/DISABLE are now identical to the version in STD.H
(under W16, they were defined as 'nothing'!
Revision 1.6  1997/01/17 20:03:20  BLA
- Correction for Windows 95
Revision 1.5  1996/12/11 15:10:14  ADR
- added CALLCONV macro
Revision 1.4  1996/12/02 11:29:32  ADR
- Undefine COR_ENABLE/DISABLE before defining them
 (conflict when both std.h and corstd.h are included).
Revision 1.2  1996/11/19 17:09:58  ADR
- Added dumm HUGE defintion for WIN NT.
Revision 1.1  1996/10/29 22:47:54  CORJEA
Initial revision
Revision 1.4  1996/10/29 22:47:54  MM
Limited the scope of COR_ENABLE, COR_DISABLE to VxDs.
Revision 1.3  1996/10/29 17:47:36  MM
Modified COR_DISABLE not to need to include dos.h.
Revision 1.2  1996/10/21 17:32:16  ADR
- Added definition for COR_DISABLE/ENABLE
Revision 1.1  1996/09/17 14:53:06  ADR
Initial revision

   1.0   Taken from Version 1.16 of std.h


**************************************************************************/

#include "corenv.h"

#if defined(__TURBOC__) && ( defined(__DPMI32__) || defined(__DPMI16__) )
#undef _Windows
#undef _WINDOWS
#endif

#if defined(_WINDOWS) || defined(_Windows)
#include <windows.h>
#define STD_WINDOWS

   #ifdef WIN32
      #ifndef HUGE
      #define HUGE
      #endif
      #ifndef CALLBACK
      #define CALLBACK            FAR PASCAL
      #endif
      #ifndef STDCALL
      #define STDCALL             _stdcall
      #endif
      #ifndef EXPORT
      #define EXPORT
      #endif
      #ifndef EXPORTFUN
      #define EXPORTFUN           EXPORT
      #endif
      #ifndef CALLCONV
      #define CALLCONV   STDCALL
      #endif
   #else//WIN16
      #ifndef HUGE
      #define HUGE   huge
      #endif
      #ifndef CALLBACK
      #define CALLBACK            _far _pascal
      #endif
      #ifndef STDCALL
      #define STDCALL
      #endif
      #ifndef EXPORT
      #define EXPORT              _export
      #endif
      #ifndef EXPORTFUN
      #define EXPORTFUN           EXPORT
      #endif
      #ifndef CALLCONV
      #define CALLCONV   CALLBACK
      #endif
   #endif//WIN32

#elif (COR_ENV_WNT && COR_TGT_DRV)

#  ifndef _NTDDK_
//#     include <ntddk.h>
#  endif

#  define NEAR
#  define FAR
#  define HUGE

/* Standard Types */
typedef BOOLEAN          BOOL;

typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned int        UINT;
typedef unsigned long       DWORD;

typedef char NEAR*          NPSTR;
typedef const char NEAR*    NPCSTR;
typedef char FAR*           LPSTR;
typedef const char FAR*     LPCSTR;

typedef BYTE NEAR*          PBYTE;
typedef BYTE FAR*           LPBYTE;

typedef int NEAR*           PINT;
typedef int FAR*            LPINT;

typedef UINT NEAR*          PUINT;
typedef UINT FAR*           LPUINT;

typedef WORD NEAR*          PWORD;
typedef WORD FAR*           LPWORD;

typedef long NEAR*          PLONG;

typedef DWORD NEAR*         PDWORD;
typedef DWORD FAR*          LPDWORD;

typedef PVOID               LPVOID;

#ifndef STDCALL
#define STDCALL
#endif
#ifndef CALLBACK
#define CALLBACK
#endif
#ifndef EXPORTFUN
#define EXPORTFUN
#endif
#ifndef EXPORT
#define EXPORT
#endif
#ifndef CALLCONV
#define CALLCONV   
#endif

#elif ((COR_ENV_W16 || COR_ENV_W95) && COR_TGT_DRV)  // Environment for Windows 3.1 VxD

//#include <vtoolsc.h>

#ifndef FAR
#define FAR
#endif

#else   // ndef Windows

#ifndef NULL
#define NULL                 0
#endif

#define VOID          void

/* Borland Power Pack */
#if defined(__TURBOC__) && defined(__DPMI32__)
#define NEAR
#else
#define NEAR          _near
#endif

  /* 32-bit Watcom Compiler   or  Borland Power Pack */
#if defined(__386__) || ( defined(__TURBOC__) && defined(__DPMI32__))
   #ifdef FAR
      #undef FAR
   #endif
   #ifdef HUGE
      #undef HUGE
   #endif
   #define FAR
   #define HUGE
#else
#define FAR           _far
#define HUGE          huge
#endif

#if (COR_ENV_WNT || COR_ENV_W95)
   #ifdef NEAR
      #undef NEAR
   #endif
   #ifdef FAR
      #undef FAR
   #endif
   #ifdef HUGE
      #undef HUGE
   #endif
   #define NEAR
   #define FAR
   #define HUGE
#endif

/* Standard Types */
typedef int        BOOL;
#define FALSE         0
#define TRUE          1

typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned long       DWORD;
typedef unsigned int        UINT;
#ifndef LONG
typedef signed long LONG;
#endif

typedef char NEAR*          NPSTR;
typedef const char NEAR*    NPCSTR;
typedef char FAR*           LPSTR;
typedef const char FAR*     LPCSTR;

typedef BYTE NEAR*          PBYTE;
typedef BYTE FAR*           LPBYTE;

typedef int NEAR*           PINT;
typedef int FAR*            LPINT;

typedef UINT NEAR*          PUINT;
typedef UINT FAR*           LPUINT;

typedef WORD NEAR*          PWORD;
typedef WORD FAR*           LPWORD;

typedef long NEAR*          PLONG;
typedef long FAR*           LPLONG;

typedef DWORD NEAR*         PDWORD;
typedef DWORD FAR*          LPDWORD;

typedef void FAR*           LPVOID;

#ifndef LOBYTE
#define  LOBYTE(l) ((BYTE)(WORD)(l))
#endif

#ifndef HIBYTE
#define HIBYTE(l) ((BYTE)((((WORD)(l)) >> 8) & 0xFF))
#endif

#ifndef STDCALL
#define STDCALL
#endif
#ifndef CALLBACK
#define CALLBACK
#endif
#ifndef EXPORT
#define EXPORT
#endif
#ifndef EXPORTFUN
#define EXPORTFUN       
#endif
#ifndef CALLCONV
#define CALLCONV   
#endif

#endif // def Windows


#ifdef COR_DISABLE
#undef COR_DISABLE
#endif

#ifdef COR_ENABLE
#undef COR_ENABLE
#endif

#if ((COR_ENV_W16 || COR_ENV_W95) && COR_TGT_DRV)        
#define COR_DISABLE { _asm { pushf }; _asm { cli }; }
#define COR_ENABLE  _asm popf
#elif ( COR_ENV_PL32)
//#include <i86.h>
	#define COR_DISABLE  _disable()
	#define COR_ENABLE   _enable()
#else
#if (COR_ENV_WNT || COR_ENV_W95) || (COR_ENV_WNT && COR_TGT_DRV)
	#define COR_DISABLE
	#define COR_ENABLE
#else
	#define COR_DISABLE 	{ BOOL bIntsEnabled= IsIntEnabled(); _disable();
	#define COR_ENABLE	  	if( bIntsEnabled) _enable();  }
#endif
#endif

typedef DWORD HOSTADDR;    /* Host Address   */
typedef void FAR * ODXPTR; /* ODx Buffer     */

// For 32-bit Operating System, force 32-bit Odx parameters
#if (COR_ENV_WNT || COR_ENV_W95 || COR_ENV_PL32 || COR_ENV_4G32)
#if !defined(ODX_32)
#define ODX_32
#endif
#endif

#ifndef _STD_H_

#if defined(ODX_32) 
// 32-bits per OPR Version
typedef DWORD ODXPARM;     // Unsigned ODx Parameter
typedef long  ODXPARM_S;   // Signed ODx Parameter
#else
// 16-bits per OPR Version
typedef WORD ODXPARM;      // Unsigned ODx Parameter
typedef short ODXPARM_S;   // Signed ODx Parameter
#endif

#endif   /* _STD_H_  */

#endif /* _CORSTD_H_ */
