#ifndef _ODX_H_
#define _ODX_H_

/**

  History:
  
	$Log: odx.h $
	Revision 1.21  1996/12/23 17:37:04  ADR
	- added LD_VGALUT definitions
	Revision 1.20  1996/12/09 16:46:40  ADR
	- Moved the if ndef STRICT outside the COR_ENV_xxx test.
	- It is now available for all Environments.
	- Added the select_minor definition for the Odx Macros.
	Revision 1.19  1996/11/15 22:00:06  ADR
	The new definitions of odxbind, odxunbind and setdmajor return int and/or take as parameters
	int as it is with the old definitions.
	Revision 1.18  1996/11/05 15:00:44  BM
	- Removed !COR_TGT_DLL condition. It was a patch that is no
	longer used.
	Revision 1.17  1996/11/04 14:27:38  BM
	- Fixed a syntax error : replaced fbgrabdilu by fbgrabdilut.
	Revision 1.16  1996/09/27 10:05:16  ADR
	- Use CORENV.H instead of ENV.H
	- Use CORSTD.H instead of STD.H
	Revision 1.15  1996/09/19 22:04:04  MM
	Added JPEGencode_setup() and JPEGencode_run(). JPEGencode() returns 
	ODXPTR so that a 32 bit value may be returned under Win16.
	Revision 1.14  1996/09/13 20:24:02  corjea
	- Changed to support new ODX interface
	Revision 1.13  1996/08/14 11:13:02  SINBAL
	removed rtp functions. 
	Revision 1.12  1996/07/25 12:31:48  Balbir
	Added the functions rtpsetfct() and rtpgetfb() for the RTP.
	Revision 1.11  1996/07/22 18:00:28  HOWROB
	* Added 'C' declarations for dspsync(), odxmap(), rdvector()
	and set_view_hwnd().
	* Changed the parameters of drwline() from short's to ODXPARMs
	(so they match what is actually in the code).
	Revision 1.10  1996/07/16 16:49:24  ADR
	- Added the 'seteventfct' function.
	Revision 1.9  1996/07/12 19:22:48  MM
	Mistake in param types to JPEGdecode() fixed.
	Revision 1.8  1996/07/12 16:53:50  MM
	Modified JPEG functions: JPEGencode takes a Yfactor parameter for integer vertical decimation,
	JPEGdecode takes Xsize, Ysize dimensions of the desired output image dimensions.
	Revision 1.7  1996/06/27 16:07:40  MM
	Modified the JPEG function prototypes to also (de)encode from/to memory.
	JPEGencode MUSTreturn a long which requires 16 bit compilation with 32bit ODX.
	Revision 1.6  1996/04/29 20:55:34  MM
	Complemented JPEG functions with odx_rcv().
	Revision 1.5  1996/04/26 15:22:20  ADR
	Added odx_close prototype. All pointer to functions are now declared as FAR _cdecl *.
	
	  1.00 September 28th, 1988 by Gag
	  
		1.01 November 8th, 1988, by Gag
        Revision for freezed specs (ODX v:3.00)
		
		  1.02 November 28,1988,Gag
		  Cast of far pointer to support small model.
		  
			1.03 June 14, 1989, Gag
			Change specs of rlen (ODX v:3.10)
			
			  1.04 Nov 27, 1989, Gag
			  Revision for ODX V:4.00
			  -Install new communication interface
			  -Add support for new Functions
			  Move error codes to opr.h
			  
				1.05 June 9, 1990, Gag
				Add support for rmwbuf, rmwline, rmwpix (will be in ODX V:4.2).
				
				  1.06 June 20, 1990, Gag
				  Gives the choice of a function or a C macro for opr_inq.
				  This is necessary if several call to opr_inq performed in an expression.
				  The bug occurs with Microsoft 5.0.
				  
					1.07 October 26th, 1990, ADR
					Added new function odxmap, fbdilut.
					kill now returns an integer.
					
					  1.08 Sept 24, 1991, Gag
					  Cast parms of mathop to a far pointer.
					  
						1.09 July 2nd, 1992, ADR
						Added the __cplusplus support.
						
						  1.10 July 20th, 1992, ADR
						  Added the fbgrabalu function.
						  
							1.11 November 30th, 1992, ADR
							Added prototype for odxunbind()
							
							  1.12 December 23rd, 1992, ADR
							  Added defvidout definition
							  
								1.13 January 26th, 1993, DT
								Add fbgrabdilut definition
								
								  1.14 February 4th, 1993, ADR
								  Added pixbltpage function.
								  Added hwconfig function.
								  
									1.15 November 25th, 1993, ADR
									Added vendorid function.
									
									  1.16  February 24th, 1994, ADR
									  Added the function odx_timeout.
									  
										1.20  March 24th, 1994, ADR
										Added the function setfbsize and rdfbhisto
										Added the function clrhostint
										
										  1.21  April 21st, 1994, ADR
										  Modified the parameters to vendorid function.
										  
											1.22  May 3rd, 1994, ADR
											Added the setcamera function.
											Added the defcamera function.
											
											  1.23  June 27th, 1994, ADR
											  Added the rdvector function.
											  Added the wtvector function.
											  
												1.24  July 19th, 1994, ADR
												Added the odxuser function
												Added the casting of all parameters to ODXPARM (16-bit unsigned)
												Added the casting of all references to ODXPTR (32-bit pointer)
												Added the driverid function
												Final revision for ODXVER 4.35
												
												  1.25  December, 8th, 1994, JPC
												  Added mdpixblt function
												  
													1.26  December 8th, 1994, ADR
													Added the 'odxabort' function.
													
													  1.27  March 24th, 1995, ADR
													  Modified the parameter list of mdpixblt.
													  
														1.28  May 29th, 1995, ADR
														Added rdfbrlen function.
														
														  1.29  July 17th, 1995, RH
														  Added a preprocessor directive that tests to see 
														  if ODX.H has already been included.
														  
															1.30  August 4th, 1995, ADR
															The ODx Parameters are now defined as UINT (unsigned int).
															
															  1.31  August 9th, 1995, ADR
															  Added the function acqscale.
															  
																1.32    September 11th, 1995, RH
																Added a cast of (ODXPARM_S) to the return of "ext_inq()"
																All parameters sent and received are now ODXPARM. The
																definition for ODXPARM is in std.h
																
																  1.33  September 11th, 1995, ADR
																  clrhostint now returns a value.
																  
																	1.34  September 24th, 1995, MM
																	added the set_view_hwnd function to pass the view window handle 
																	to the driver for the purposes of DCI
																	1.35  October 13th, 1995, BSD
																	added fbcycle()
																	deleted clrhostint function
																	1.36  October 18th, 1995 BSD
																	changed fbcycle so that it returns the number of frames
																	that can be captured in the frame buffer range.
																	1.37  October 19th, 1995, ADR
																	setfbcycle is now called deffbcycle and takes a new parameter: rw.
																	1.38  December 4th, 1995, ADR
																	Added the odx_check_rcv function definition.
																	
																	  
**/
#include "corstd.h"

#ifndef  ODX_STRICT

#define  OdxBind         odxbind		 
#define  OdxSetDMajor    setdmajor	 
#define  OdxUnBind    	 odxunbind	 
#define  OdxTimeOut      odx_timeout

#define  OdxAbort		 odxabort	  
#define  OdxAcqScale  	 acqscale 	 
#define  OdxAcqSync  	 acqsync		 
#define  OdxAMov      	 amov		 
#define  OdxCntr      	 cntr		 
#define  OdxCntrFirst	 cntrfirst	 
#define  OdxCntrNext	 cntrnext	 
#define  OdxConfig		 config		 
#define  OdxConvo		 convo		 
#define  OdxDefCamera	 defcamera	 
#define  OdxDefFBCycle	 deffbcycle	 
#define  OdxDefVidIn	 defvidin	 
#define  OdxDefVidOut	 defvidout	 
#define  OdxDriverID	 driverid	 
#define  OdxDrwBox		 drwbox		 
#define  OdxDrwCirc	 	 drwcirc		 
#define  OdxDrwDots	 	 drwdots		 
#define  OdxDrwLine	 	 drwline		 
#define  OdxDspSync	 	 dspsync		 
#define  OdxDWin		 dwin		 
#define  OdxEvent		 event		 
#define  OdxExtInq		 ext_inq		 
#define  OdxFBAlu		 fbalu		 
#define  OdxFBCopy		 fbcopy		 
#define  OdxFBDilut	 	 fbdilut		 
#define  OdxFBGrab		 fbgrab		 
#define  OdxFBGrabAlu	 fbgrabalu	 
#define  OdxFBGrabDilut  fbgrabdilut
#define  OdxFBSet		 fbset		 
#define  OdxFBWave		 fbwave		 
#define  OdxFormat		 format		 
#define  OdxFWin		 fwin		 
#define  OdxHisto		 histo		 
#define  OdxHwConfig	 hwconfig	 
#define  OdxID			 odxid		  
#define  OdxJPEGDecode	 JPEGdecode	 
#define  OdxJPEGEncode	 JPEGencode	 
#define  OdxJPEGEncodeSetup	 JPEGencode_setup	 
#define  OdxJPEGEncodeRun	 JPEGencode_run	 
#define  OdxJPEGInit	 JPEGinit	 
#define  OdxJPEGTerm	 JPEGterm	 
#define  OdxKill		 kill		 
#define  OdxLdBLut		 ld_blut		 
#define  OdxLdILut		 ld_ilut		 
#define  OdxLdOLut		 ld_olut		 
#define  OdxLdVgaLut     ld_vgalut
#define  OdxLutOp		 lutop		 
#define  OdxMap		  	 odxmap		 
#define  OdxMathOp		 mathop		 
#define  OdxMdPixBlt	 mdpixblt	 
#define  OdxMemOpen	 	 memopen		 
#define  OdxMemClose	 memclose	 
#define  OdxMemROpen	 memropen	 
#define  OdxMorpho		 morpho		  
#define  OdxMyUser       myuser
#define  OdxOprInq		 opr_inq		  
#define  OdxOprSet		 opr_set		  
#define  OdxPaint		 paint		  
#define  OdxPixBlt		 pixblt		  
#define  OdxPixBltPage	 pixbltpage	  
#define  OdxPixPtn		 pixptn		  
#define  OdxProfile	  	 profile		 
#define  OdxPWin		 pwin		  
#define  OdxRdBuf		 rdbuf		  
#define  OdxRdFBHisto	 rdfbhisto	  
#define  OdxRdFBRlen	 rdfbrlen	  
#define  OdxRdLine		 rdline		  
#define  OdxRdPix		 rdpix		  
#define  OdxReset		 reset		  
#define  OdxRdVector	 rdvector	  
#define  OdxRLen		 rlen		  
#define  OdxRMWBuf		 rmwbuf		  
#define  OdxRMWLine	  	 rmwline		 
#define  OdxRMWPix		 rmwpix		  
#define  OdxROA		  	 roa			 
#define  OdxSelect		 select_minor  
#define  OdxSetCamera	 setcamera	  
#define  OdxSetEventFct  seteventfct  
#define  OdxSetFbSize	 setfbsize	  
#define  OdxSetViewHWnd  set_view_hwnd
#define  OdxTarget		 target		  
#define  OdxText		 text		  
#define  OdxUser		 odxuser		  
#define  OdxVendorID	 vendorid	  
#define  OdxVidIn		 vidin		  
#define  OdxVidOut		 vidout		  
#define  OdxWtBuf		 wtbuf		  
#define  OdxWtLine		 wtline		  
#define  OdxWtPix		 wtpix		  
#define  OdxWtVector	 wtvector	  
#define  OdxZoom		 zoom		  
#endif /* ndef ODX_STRICT */


#if (( COR_ENV_W95 || COR_ENV_WNT ))

#define  ODXCCONV		 _stdcall


#ifdef __cplusplus
extern "C" {
#endif
	extern int       ODXCCONV  OdxBind           ( void);                      /* Bind to ODX drivers installed */
	extern void      ODXCCONV  OdxSetDMajor      ( int);                   /* Set working major device */
	extern int       ODXCCONV  OdxUnBind    	   ( void);
	//extern void      ODXCCONV  OdxTimeOut        (unsigned); 
	
	extern void      ODXCCONV  OdxAbort		       ( void);
	extern void      ODXCCONV  OdxAcqScale  	   ( ODXPARM h, ODXPARM v);
	extern void      ODXCCONV  OdxAcqSync  		   ( void);
	extern void      ODXCCONV  OdxAMov      	   ( ODXPARM X, ODXPARM Y);
	extern ODXPARM   ODXCCONV  OdxCntr      	   ( ODXPARM xstop, ODXPARM ystop, ODXPTR ldot, ODXPARM nmax);
	extern ODXPARM   ODXCCONV  OdxCntrFirst	       ( void); 
	extern ODXPARM   ODXCCONV  OdxCntrNext	       ( ODXPTR Feat, ODXPTR dot, ODXPARM Nmax); 
	extern void      ODXCCONV  OdxConfig		   ( ODXPARM Rw, ODXPTR lpConfig);
	extern void      ODXCCONV  OdxConvo		       ( ODXPTR Mask, ODXPARM Xs, ODXPARM Ys); 
	extern void      ODXCCONV  OdxDefCamera	       ( ODXPARM Rw, ODXPARM CamId, ODXPTR pCamdef, ODXPARM Size);
	extern ODXPARM   ODXCCONV  OdxDefFBCycle	   ( ODXPARM rw, ODXPTR cycledef);
	extern void      ODXCCONV  OdxDefVidIn	       ( ODXPARM Rw, ODXPTR lpVidef);
	extern void      ODXCCONV  OdxDefVidOut	       ( ODXPARM Rw, ODXPTR lpVodef); 
	extern ODXPARM   ODXCCONV  OdxDriverID	       ( ODXPTR buf, ODXPARM size);
	extern void      ODXCCONV  OdxDrwBox		   ( ODXPARM Fill);
	extern void      ODXCCONV  OdxDrwCirc	       ( ODXPARM r, ODXPARM hsf);
	extern void      ODXCCONV  OdxDrwDots	       ( ODXPTR Ldots, ODXPARM N); 
	extern void      ODXCCONV  OdxDrwLine	       ( ODXPARM X, ODXPARM Y); 
	extern void      ODXCCONV  OdxDspSync	       ( void);
	extern void      ODXCCONV  OdxDWin		       ( ODXPARM Xmin, ODXPARM Ymin, ODXPARM Xlen, ODXPARM Ylen);
	extern void      ODXCCONV  OdxEvent		       ( ODXPARM vscnt, ODXPARM line, ODXPTR fctptr);
	extern ODXPARM_S ODXCCONV  OdxExtInq		   ( ODXPARM Fn);
	extern void      ODXCCONV  OdxFBAlu		       ( ODXPARM Op, ODXPARM Fb); 
	extern void      ODXCCONV  OdxFBCopy		   ( ODXPARM fb);
	extern void      ODXCCONV  OdxFBDilut	       ( ODXPARM op, ODXPARM n, ODXPARM_S cfb, ODXPARM sfb);
	extern void      ODXCCONV  OdxFBGrab		   ( ODXPARM_S Mode);
	extern void      ODXCCONV  OdxFBGrabAlu	       ( ODXPARM op, ODXPARM fb, ODXPARM_S mode);
	extern void      ODXCCONV  OdxFBGrabDilut      ( ODXPARM op, ODXPARM n, ODXPARM_S cfb, ODXPARM sfb, ODXPARM_S mode);
	extern void      ODXCCONV  OdxFBSet		       ( ODXPARM Grl);                               
	extern void      ODXCCONV  OdxFBWave		   ( ODXPARM n, ODXPARM_S mode);
	extern void      ODXCCONV  OdxFormat		   ( ODXPARM Mode);
	extern void      ODXCCONV  OdxFWin		       ( ODXPARM Xmin, ODXPARM Ymin, ODXPARM Xlen, ODXPARM Ylen);
	extern void      ODXCCONV  OdxHisto		       ( ODXPTR Historef, ODXPARM Class, ODXPARM Nind, ODXPARM Nsht); 
	extern void      ODXCCONV  OdxHwConfig	       ( ODXPTR Buf, ODXPARM Size);
	extern ODXPARM   ODXCCONV  OdxID			   ( ODXPTR lpStr);
	extern ODXPARM   ODXCCONV  OdxJPEGDecode	   ( ODXPTR source, ODXPARM xsize, ODXPARM ysize, ODXPARM to_mem);
	extern ODXPTR    ODXCCONV  OdxJPEGEncode	   ( ODXPTR target, ODXPARM qf, ODXPARM xsize, ODXPARM yfactor, ODXPARM color_fmt, ODXPARM to_mem);
	extern ODXPARM   ODXCCONV  OdxJPEGEncodeSetup	   ( ODXPTR target, ODXPARM qf, ODXPARM xsize, ODXPARM yfactor, ODXPARM color_fmt, ODXPARM to_mem);
	extern ODXPARM   ODXCCONV  OdxJPEGEncodeRun	   (void);
	extern ODXPARM   ODXCCONV  OdxJPEGInit	       ( ODXPARM code_type);
	extern ODXPARM   ODXCCONV  OdxJPEGTerm	       ( void);
	extern void      ODXCCONV  OdxKill		       ( void);
	extern void      ODXCCONV  OdxLdBLut		   ( ODXPTR Blut); 
	extern void      ODXCCONV  OdxLdILut		   ( ODXPTR lpSlut);
	extern void      ODXCCONV  OdxLdOLut		   ( ODXPTR Palette);
	extern void      ODXCCONV  OdxLdVgaLut		   ( ODXPTR lpSlut);
	extern void      ODXCCONV  OdxLutOp		       ( ODXPTR Slut); 
	extern void      ODXCCONV  OdxMap		       ( ODXPTR grp, ODXPARM bufsiz);
	extern void      ODXCCONV  OdxMathOp		   ( ODXPARM Op, ODXPTR Buffer); 
	extern void      ODXCCONV  OdxMdPixBlt	       ( ODXPARM Odi, ODXPARM Fb, ODXPARM X, ODXPARM Y);
	extern ODXPTR    ODXCCONV  OdxMemOpen	       ( ODXPARM mbk);
	extern void      ODXCCONV  OdxMemClose	       ( ODXPARM mbk);
	extern ODXPTR    ODXCCONV  OdxMemROpen	       ( ODXPARM obk, ODXPARM nbk);
	extern void      ODXCCONV  OdxMorpho		   ( ODXPARM Op); 
	extern ODXPARM   ODXCCONV  OdxMyUser         ( ODXPARM index, ODXPTR buf);
	extern ODXPARM   ODXCCONV  OdxOprInq		   ( ODXPARM Prn);
	extern void      ODXCCONV  OdxOprSet		   ( ODXPARM Prn, ODXPARM Value);
	extern void      ODXCCONV  OdxPaint		       ( ODXPARM Edge); 
	extern void      ODXCCONV  OdxPixBlt		   ( ODXPARM Fb, ODXPARM Dir); 
	extern void      ODXCCONV  OdxPixBltPage	   ( ODXPARM Fb, ODXPARM Pfbpage, ODXPARM Dir); 
	extern void      ODXCCONV  OdxPixPtn		   ( ODXPTR buf, ODXPARM size, ODXPARM grl0, ODXPARM grl1);
	extern void      ODXCCONV  OdxProfile	       ( ODXPARM Dir, ODXPTR Buf); 
	extern void      ODXCCONV  OdxPWin		       ( ODXPARM Xmin, ODXPARM Ymin, ODXPARM Xlen, ODXPARM Ylen);
	extern void      ODXCCONV  OdxRdBuf		       ( ODXPTR lpBuf, ODXPARM_S Bmw);
	extern void      ODXCCONV  OdxRdFBHisto	       ( ODXPTR histo, ODXPARM clas, ODXPARM nind, ODXPARM nsht);
	extern ODXPARM   ODXCCONV  OdxRdFBRlen	       ( ODXPTR grp, ODXPARM bufsiz);
	extern void      ODXCCONV  OdxRdLine		   ( ODXPTR lpDst, ODXPARM Dir, ODXPARM Cnt);
	extern ODXPARM   ODXCCONV  OdxRdPix		       ( ODXPARM Dir);
	extern void      ODXCCONV  OdxReset		       ( void);
	extern ODXPARM   ODXCCONV  OdxRdVector	       ( ODXPTR buf, ODXPARM size, ODXPARM x0, ODXPARM y0, ODXPARM x1, ODXPARM y1);
	extern ODXPARM   ODXCCONV  OdxRLen		       ( ODXPTR buf, ODXPARM bufsize);
	extern void      ODXCCONV  OdxRMWBuf		   ( ODXPTR buf, ODXPARM bmw);
	extern void      ODXCCONV  OdxRMWLine	       ( ODXPTR buf, ODXPARM dir, ODXPARM cnt);
	extern void      ODXCCONV  OdxRMWPix		   ( ODXPARM Grl, ODXPARM Dir); 
	extern void      ODXCCONV  OdxROA		       ( ODXPARM Range, ODXPARM Offset);
	extern void      ODXCCONV  OdxSelect		   ( ODXPARM Odi);
	extern void      ODXCCONV  OdxSetCamera	       ( ODXPARM Camera);
	extern void      ODXCCONV  OdxSetEventFct      ( ODXPTR function);
	extern void      ODXCCONV  OdxSetFbSize	       ( ODXPARM mw, ODXPARM mh);
	extern void      ODXCCONV  OdxSetViewHWnd      ( ODXPARM hwnd, ODXPARM toggle);
	extern void      ODXCCONV  OdxTarget		   ( void);
	extern void      ODXCCONV  OdxText		       ( ODXPTR Str, ODXPARM N, ODXPARM Grl0, ODXPARM Grl1); 
	extern ODXPARM   ODXCCONV  OdxUser		       ( ODXPARM index, ODXPTR buf);
	extern ODXPARM   ODXCCONV  OdxVendorID	       ( ODXPTR buf, ODXPARM size);
	extern void      ODXCCONV  OdxVidIn		       ( ODXPARM Format, ODXPARM _hsfi, ODXPARM Vsf, ODXPARM Hmin, ODXPARM Vmin);
	extern void      ODXCCONV  OdxVidOut		   ( ODXPARM uFormat, ODXPARM uHzf, ODXPARM uVzf, ODXPARM uHmin, ODXPARM uVmin);
	extern void      ODXCCONV  OdxWtBuf		       ( ODXPTR lpBuf, ODXPARM_S Bmw);
	extern void      ODXCCONV  OdxWtLine		   ( ODXPTR lpSrc, ODXPARM Dir, ODXPARM Cnt);
	extern void      ODXCCONV  OdxWtPix		       ( ODXPARM Grl, ODXPARM Dir);
	extern void      ODXCCONV  OdxWtVector	       ( ODXPTR buf, ODXPARM size, ODXPARM x0, ODXPARM y0, ODXPARM x1, ODXPARM y1);
	extern void      ODXCCONV  OdxZoom		       ( ODXPARM Fb, ODXPARM Zf); 
	
#ifdef  __cplusplus
}
#endif

#else   /* W95/WNT */

#ifdef __cplusplus
extern "C" {
#endif
	extern void (FAR _cdecl *odx_send) (ODXPARM,...);               /* Send a message to odx */
	extern ODXPARM (FAR _cdecl *odx_rcvi) (void);                   /* Receive an integer value */
	extern ODXPTR (FAR _cdecl *odx_rcvl) (void);                    /* Receive an address or long value */
	extern void (FAR _cdecl *odx_close) (void);              /* Cleanup before unloading driver */
															 extern void (FAR _cdecl *odx_timeout)( unsigned seconds);/* Set the time out interval to wait
															 for a response from an ODx device */
															 extern int (FAR _cdecl *odx_check_rcv)(void);            /* Check if receive value(s) are ready */
															 
															 
															 extern int  FAR odxbind(void);                           /* Bind to ODX drivers installed */
															 extern void FAR setdmajor(int);                     /* Set working major device */
															 extern int FAR odxunbind( void);
															 
															 
#ifdef OPR_INQ_FUNC
															 extern int opr_inq( int);                       /* Define in odxcall.c */
#endif
															 
#ifdef  __cplusplus
}
#endif

#define is_odx_rcv()                            ((*odx_check_rcv)())

#define amov( x, y)                             (*odx_send)((ODXPARM)0, (ODXPARM)(x), (ODXPARM)(y))
#define convo( mask, xs, ys)                    (*odx_send)((ODXPARM)1, (ODXPTR) (mask), (ODXPARM)(xs), (ODXPARM)(ys))
#define drwbox( fill)                           (*odx_send)((ODXPARM)2, (ODXPARM)(fill))
#define drwcirc( r, hsf)                        (*odx_send)((ODXPARM)3, (ODXPARM)(r), (ODXPARM)(hsf))
#define drwdots( ldir, n)                       (*odx_send)((ODXPARM)4, (ODXPTR) (ldir), (ODXPARM)(n))
#define drwline( x, y)                          (*odx_send)((ODXPARM)5, (ODXPARM)(x), (ODXPARM)(y))
#define dwin( xmin, ymin, xlen, ylen)           (*odx_send)((ODXPARM)6, (ODXPARM)(xmin), (ODXPARM)(ymin), (ODXPARM)(xlen), (ODXPARM)(ylen))
#define ext_inq( op)                            ((*odx_send)((ODXPARM)7, (ODXPARM)(op)), (ODXPARM_S)(*odx_rcvi)())
#define morpho( mode)                           (*odx_send)((ODXPARM)8, (ODXPARM)(mode))
#define fbalu( op, fb)                          (*odx_send)((ODXPARM)9, (ODXPARM)(op), (ODXPARM)(fb))                       
#define fbcopy( fb)                             (*odx_send)((ODXPARM)10, (ODXPARM)(fb))                           
#define fbgrab( mode)                           (*odx_send)((ODXPARM)11, (ODXPARM_S)(mode))                         
#define fbset( grl)                             (*odx_send)((ODXPARM)12, (ODXPARM)(grl))                          
#define fbsnap( seq, n)                         (*odx_send)((ODXPARM)13, (ODXPTR) (seq), (ODXPARM)(n))
#define fbwave( n, mode)                        (*odx_send)((ODXPARM)14, (ODXPARM)(n), (ODXPARM_S)(mode))                      
#define format( mode)                           (*odx_send)((ODXPARM)15, (ODXPARM)(mode))                         
#define fwin( xmin, ymin, xlen, ylen)           (*odx_send)((ODXPARM)16, (ODXPARM)(xmin), (ODXPARM)(ymin), (ODXPARM)(xlen), (ODXPARM)(ylen))       
#define histo( h, class, nind, nsht)            ((*odx_send)((ODXPARM)17, (ODXPTR) (h), (ODXPARM)(class), (ODXPARM)(nind), (ODXPARM)(nsht)), (*odx_rcvi)())
#define ld_ilut( slut)                          (*odx_send)((ODXPARM)18, (ODXPTR) (slut))
#define ld_olut( slut)                          (*odx_send)((ODXPARM)19, (ODXPTR) (slut))
#define lutop( slut)                            (*odx_send)((ODXPARM)20, (ODXPTR) (slut))
#define memclose( mbk)                          (*odx_send)((ODXPARM)21, (ODXPARM)(mbk))
#define memopen( mbk)                           ((*odx_send)((ODXPARM)22, (ODXPARM)(mbk)), (*odx_rcvl)())  
#define memropen( old, new)                     ((*odx_send)((ODXPARM)23, (ODXPARM)(old), (ODXPARM)(new)), (*odx_rcvl)())

#ifndef OPR_INQ_FUNC
#define opr_inq( prn)                           ((*odx_send)((ODXPARM)24, (ODXPARM)(prn)), (*odx_rcvi)())
#endif

#define opr_set( prn, value)                    (*odx_send)((ODXPARM)25, (ODXPARM)(prn), (ODXPARM)(value))
#define paint( edge)                            (*odx_send)((ODXPARM)26, (ODXPARM)(edge))
#define pixblt( fb, dir)                        (*odx_send)((ODXPARM)27, (ODXPARM)(fb), (ODXPARM)(dir))                      
#define pixptn( buf, size, grl0, grl1)          (*odx_send)((ODXPARM)28, (ODXPTR) (buf), (ODXPARM)(size), (ODXPARM)(grl0), (ODXPARM)(grl1))        
#define profile( dir, buf)                      ((*odx_send)((ODXPARM)29, (ODXPARM)(dir), (ODXPTR) (buf)), (*odx_rcvi)())
#define pwin( xmin, ymin, xlen, ylen)           (*odx_send)((ODXPARM)30, (ODXPARM)(xmin), (ODXPARM)(ymin), (ODXPARM)(xlen), (ODXPARM)(ylen))       
#define rdbuf( buf, bmw)                        ((*odx_send)((ODXPARM)31, (ODXPTR) (buf), (ODXPARM_S)(bmw)), (*odx_rcvi)())
#define rdline( buf, dir, cnt)                  ((*odx_send)((ODXPARM)32, (ODXPTR) (buf), (ODXPARM)(dir), (ODXPARM)(cnt)), (*odx_rcvi)())
#define rdpix( dir)                             ((*odx_send)((ODXPARM)33, (ODXPARM)(dir)), (*odx_rcvi)())
#define rlen( grp, bufsiz)                      ((*odx_send)((ODXPARM)34, (ODXPTR) (grp), (ODXPARM)(bufsiz)), (*odx_rcvi)())
#define roa( range, offset)                     (*odx_send)((ODXPARM)35, (ODXPARM)(range), (ODXPARM)(offset))                
#define select_minor select
#define select( odi)                            (*odx_send)((ODXPARM)36, (ODXPARM)(odi))                          
#define target()                                (*odx_send)((ODXPARM)37)                                
#define vidin( format, hsfi, vsf, hmin, vmin)   (*odx_send)((ODXPARM)38, (ODXPARM)(format), (ODXPARM)(hsfi), (ODXPARM)(vsf), (ODXPARM)(hmin), (ODXPARM)(vmin)) 
#define vidout( format, hzf, vzf, hmin, vmin)   (*odx_send)((ODXPARM)39, (ODXPARM)(format), (ODXPARM)(hzf), (ODXPARM)(vzf), (ODXPARM)(hmin), (ODXPARM)(vmin)) 
#define wtbuf( buf, bmw)                        (*odx_send)((ODXPARM)40, (ODXPTR) (buf), (ODXPARM_S)(bmw))
#define wtline( buf, dir, cnt)                  (*odx_send)((ODXPARM)41, (ODXPTR) (buf), (ODXPARM)(dir), (ODXPARM)(cnt))
#define wtpix( grl, dir)                        (*odx_send)((ODXPARM)42, (ODXPARM)(grl), (ODXPARM)(dir))
#define ld_vgalut( slut)                        ((*odx_send)( EX_LD_VGALUT, (ODXPTR) (slut)))
#define myuser( index, buf)                     ((*odx_send)((ODXPARM)45, (ODXPARM)(index), (ODXPTR) (buf)), (*odx_rcvl)())
#define acqsync()                               (*odx_send)((ODXPARM)46)
#define odxuser( index, buf)                    ((*odx_send)((ODXPARM)47, (ODXPARM)(index), (ODXPTR) (buf)), (*odx_rcvl)())
#define defvidout( rw, vodef)                   ((*odx_send)((ODXPARM)48, (ODXPARM)(rw), (ODXPTR) (vodef)), (*odx_rcvi)())
#define config( rw, buf)                        ((*odx_send)((ODXPARM)49, (ODXPARM)(rw), (ODXPTR) (buf)), (*odx_rcvi)())
#define reset()                                 (*odx_send)((ODXPARM)50)
#define kill()                                  ((*odx_send)((ODXPARM)51), (*odx_rcvi)())
#define cntr( xstop, ystop, ldot, nmax)         ((*odx_send)((ODXPARM)52, (ODXPARM)(xstop), (ODXPARM)(ystop), (ODXPTR) (ldot), (ODXPARM)(nmax)), (*odx_rcvi)())
#define cntrfirst()                             ((*odx_send)((ODXPARM)53), (*odx_rcvi)())
#define cntrnext( feat, ldot, nmax)             ((*odx_send)((ODXPARM)54, (ODXPTR) (feat), (ODXPTR) (ldot), (ODXPARM)(nmax)), (*odx_rcvi)())
#define defvidin( rw, videf)                    ((*odx_send)((ODXPARM)55, (ODXPARM)(rw), (ODXPTR) (videf)), (*odx_rcvi)())
#define dspsync()                               (*odx_send)((ODXPARM)56)
#define event( vscnt, line, fctptr)             (*odx_send)((ODXPARM)57, (ODXPARM)(vscnt), (ODXPARM)(line), (ODXPTR) (fctptr))
#define ld_blut( slut)                          (*odx_send)((ODXPARM)58, (ODXPTR) (slut))
#define odxid( str)                             ((*odx_send)((ODXPARM)59, (ODXPTR) (str)), (*odx_rcvi)())
#define text( str, n, grl0, grl1)               (*odx_send)((ODXPARM)60, (ODXPTR) (str), (ODXPARM)(n), (ODXPARM)(grl0), (ODXPARM)(grl1))
#define zoom( fb, n)                            (*odx_send)((ODXPARM)61, (ODXPARM)(fb), (ODXPARM)(n))
#define mathop( op, parms)                      (*odx_send)((ODXPARM)62, (ODXPARM)(op), (ODXPTR)(parms))
#define rmwbuf( buf, bmw)                       (*odx_send)((ODXPARM)63, (ODXPTR) (buf), (ODXPARM_S)(bmw))
#define rmwline( buf, dir, cnt)                 (*odx_send)((ODXPARM)64, (ODXPTR) (buf), (ODXPARM)(dir), (ODXPARM)(cnt))
#define rmwpix( grl, dir)                       (*odx_send)((ODXPARM)65, (ODXPARM)(grl), (ODXPARM)(dir))
#define odxmap( grp, bufsiz)                    ((*odx_send)((ODXPARM)66, (ODXPTR) (grp), (ODXPARM)(bufsiz)), (*odx_rcvi)())
#define fbdilut( op, n, cfb, sfb)               (*odx_send)((ODXPARM)67, (ODXPARM)(op), (ODXPARM)(n), (ODXPARM)(cfb), (ODXPARM)(sfb))
#define fbgrabalu( op, fb, mode)                (*odx_send)((ODXPARM)68, (ODXPARM)(op), (ODXPARM)(fb), (ODXPARM_S)(mode))                       
#define fbgrabdilut( op, n, cfb, sfb, mode)     (*odx_send)((ODXPARM)69, (ODXPARM)(op), (ODXPARM)(n), (ODXPARM)(cfb), (ODXPARM)(sfb), (ODXPARM_S)(mode))
#define pixbltpage( fb, pfbpage, dir)           (*odx_send)((ODXPARM)70, (ODXPARM)(fb), (ODXPARM)(pfbpage), (ODXPARM)(dir))                      
#define hwconfig( config, size)                 ((*odx_send)((ODXPARM)71, (ODXPTR) (config), (ODXPARM)(size)), (*odx_rcvi)())
#define vendorid( buf, size)                    ((*odx_send)((ODXPARM)72, (ODXPTR) (buf), (ODXPARM)(size)), (*odx_rcvi)())
#define rdfbhisto( h, class, nind, nsht)        ((*odx_send)((ODXPARM)73, (ODXPTR) (h), (ODXPARM)(class), (ODXPARM)(nind), (ODXPARM)(nsht)), (*odx_rcvi)())
#define setfbsize( mw, mh)                      ((*odx_send)((ODXPARM)74, (ODXPARM)(mw), (ODXPARM)(mh)))
#define deffbcycle( rw, cycledef)               ((*odx_send)((ODXPARM)75, (ODXPARM) (rw), (ODXPTR)(cycledef)), (*odx_rcvi)())
#define setcamera( camid)                       ((*odx_send)((ODXPARM)76, (ODXPARM)(camid)))
#define defcamera( rw, camid, camdef, size)     ((*odx_send)((ODXPARM)77, (ODXPARM)(rw), (ODXPARM)(camid), (ODXPTR) (camdef), (ODXPARM)(size)), (*odx_rcvi)())
#define rdvector( buf, size, x0, y0, x1, y1)    ((*odx_send) ((ODXPARM)78, (ODXPTR)(buf), (ODXPARM)(size), (ODXPARM)(x0), (ODXPARM)(y0), (ODXPARM)(x1), (ODXPARM)(y1)), (*odx_rcvi)())
#define wtvector( buf, size, x0, y0, x1, y1)    (*odx_send) ((ODXPARM)79, (ODXPTR)(buf), (ODXPARM)(size), (ODXPARM)(x0), (ODXPARM)(y0), (ODXPARM)(x1), (ODXPARM)(y1))
#define driverid( buf, size)                    ((*odx_send)((ODXPARM)80, (ODXPTR) (buf), (ODXPARM)(size)), (*odx_rcvi)())
#define mdpixblt( odi, fb, x, y)                ((*odx_send)((ODXPARM)81, (ODXPARM)(odi), (ODXPARM) (fb), (ODXPARM) (x), (ODXPARM)(y)))
#define odxabort()                              (*odx_send)((ODXPARM)82)
#define rdfbrlen( grp, bufsiz)                  ((*odx_send)((ODXPARM)83, (ODXPTR)(grp), (ODXPARM)(bufsiz)), (*odx_rcvi)())
#define acqscale( h, v)                         ((*odx_send)((ODXPARM)84, (ODXPARM)(h), (ODXPARM) (v)))
#define set_view_hwnd(hwnd, toggle)             ((*odx_send)((ODXPARM)85, (ODXPARM)(hwnd), (ODXPARM) (toggle)))
#define JPEGinit( codetype)                     ((*odx_send)((ODXPARM)86, (ODXPARM) (codetype)), (*odx_rcvi)())
#define JPEGencode( target, qf, xsize, yfactor, colorfmt, to_mem) ((*odx_send)((ODXPARM)87, (ODXPTR)(target), (ODXPARM)(qf), (ODXPARM)(xsize), (ODXPARM)(yfactor), (ODXPARM)(colorfmt), (ODXPARM)(to_mem)), (*odx_rcvl)())
#define JPEGdecode( source, xsize, ysize, from_mem)             ((*odx_send)((ODXPARM)88, (ODXPTR)(source),  (ODXPARM)(xsize),  (ODXPARM)(ysize), (ODXPARM)(from_mem)), (*odx_rcvi)())
#define JPEGterm()                              ((*odx_send)((ODXPARM)89), (*odx_rcvi)())
#define seteventfct( function)                  (*odx_send)((ODXPARM)90, (ODXPTR)(function))
#define JPEGencode_setup( target, qf, xsize, yfactor, colorfmt, to_mem) ((*odx_send)((ODXPARM)91, (ODXPTR)(target), (ODXPARM)(qf), (ODXPARM)(xsize), (ODXPARM)(yfactor), (ODXPARM)(colorfmt), (ODXPARM)(to_mem)), (*odx_rcvi)())
#define JPEGencode_run() 								((*odx_send)((ODXPARM)92), (*odx_rcvi)())
#endif

#endif /* W95/WNT */
